clear
clear
set mem 500m
set matsize 800
set more off
#delimit ;
set more off;
use data_AER_FSBO_MLS, clear;

* generate geographic variables to include simplified gradients from center of town;
* 101 e washington street is dane_lat dane_long ;
* 821726.5 483136.5 ;
* 110 w washington stree is dane_lat dane_long ;
* 820651 482564.4 ;
* state street brats is at lat 817998.5 long 482806.09 ;

scalar cbd_lat = 817998.5;
scalar cbd_long = 482806.09 ;

gen d_lat_SSB = abs(Dane_lat - cbd_lat) ;
gen d_long_SSB = abs(Dane_long - cbd_long) ;
gen d_SSB = ((d_lat_SSB^2 + d_long_SSB^2)^.5)/10000 ;
gen d_SSB_2 = d_SSB^2 ;
gen d_SSB_ne = d_SSB*(Dane_lat >= cbd_lat)*(Dane_long >= cbd_long) + 0 ;
gen d_SSB_se = d_SSB*(Dane_lat < cbd_lat)*(Dane_long >= cbd_long) + 0 ;
gen d_SSB_nw = d_SSB*(Dane_lat >= cbd_lat)*(Dane_long < cbd_long) + 0 ;
gen d_SSB_sw = d_SSB*(Dane_lat < cbd_lat)*(Dane_long < cbd_long) + 0 ;
 
gen d_SSB_nne = d_SSB*(Dane_lat >= cbd_lat)*(Dane_long >= cbd_long)*(Dane_long-cbd_long>=Dane_lat-cbd_lat)+0 ;
gen d_SSB_nee = d_SSB*(Dane_lat >= cbd_lat)*(Dane_long >= cbd_long)*(Dane_long-cbd_long<Dane_lat-cbd_lat)+0 ;
gen d_SSB_see = d_SSB*(Dane_lat < cbd_lat)*(Dane_long >= cbd_long)*(Dane_long-cbd_long>=-Dane_lat+cbd_lat)+0; 
gen d_SSB_sse = d_SSB*(Dane_lat < cbd_lat)*(Dane_long >= cbd_long)*(Dane_long-cbd_long<-Dane_lat+cbd_lat)+0 ;
gen d_SSB_nnw = d_SSB*(Dane_lat >= cbd_lat)*(Dane_long < cbd_long)*(-Dane_long+cbd_long<Dane_lat-cbd_lat)+0; 
gen d_SSB_nww = d_SSB*(Dane_lat >= cbd_lat)*(Dane_long < cbd_long)*(-Dane_long+cbd_long>=Dane_lat-cbd_lat)+0 ;
gen d_SSB_sww = d_SSB*(Dane_lat < cbd_lat)*(Dane_long < cbd_long)*(-Dane_long+cbd_long<-Dane_lat+cbd_lat)+0 ;
gen d_SSB_ssw = d_SSB*(Dane_lat < cbd_lat)*(Dane_long < cbd_long)*(-Dane_long+cbd_long>=-Dane_lat+cbd_lat)+0 ;

gen d_SSB_ne_2 = d_SSB_ne^2 ;
gen d_SSB_nw_2 = d_SSB_nw^2; 
gen d_SSB_se_2 = d_SSB_se^2 ;
gen d_SSB_sw_2 = d_SSB_sw^2; 

gen d_SSB_ne_3 = d_SSB_ne^3 ;
gen d_SSB_nw_3 = d_SSB_nw^3; 
gen d_SSB_se_3 = d_SSB_se^3 ;
gen d_SSB_sw_3 = d_SSB_sw^3; 
 
gen d_SSB_nne_2 = d_SSB_nne^2; 
gen d_SSB_nnw_2 = d_SSB_nnw^2; 
gen d_SSB_sse_2 = d_SSB_sse^2 ;
gen d_SSB_ssw_2 = d_SSB_ssw^2; 
gen d_SSB_nee_2 = d_SSB_nee^2 ;
gen d_SSB_nww_2 = d_SSB_nww^2; 
gen d_SSB_see_2 = d_SSB_see^2 ;
gen d_SSB_sww_2 = d_SSB_sww^2; 
 
gen d_SSB_nne_3 = d_SSB_nne^3 ;
gen d_SSB_nnw_3 = d_SSB_nnw^3; 
gen d_SSB_sse_3 = d_SSB_sse^3 ;
gen d_SSB_ssw_3 = d_SSB_ssw^3; 
gen d_SSB_nee_3 = d_SSB_nee^3 ;
gen d_SSB_nww_3 = d_SSB_nww^3; 
gen d_SSB_see_3 = d_SSB_see^3 ;
gen d_SSB_sww_3 = d_SSB_sww^3; 
 
gen d_SSB_nne_4 = d_SSB_nne^4 ;
gen d_SSB_nnw_4 = d_SSB_nnw^4; 
gen d_SSB_sse_4 = d_SSB_sse^4 ;
gen d_SSB_ssw_4 = d_SSB_ssw^4; 
gen d_SSB_nee_4 = d_SSB_nee^4 ;
gen d_SSB_nww_4 = d_SSB_nww^4; 
gen d_SSB_see_4 = d_SSB_see^4 ;
gen d_SSB_sww_4 = d_SSB_sww^4;


* generate some descriptive varaibles;
gen tot_area =  ground_floor_area + t2nd_floor_area + t3rd_floor_area + above_3rd_floor_area + additions_area 
    + finished_attic_area  +  finished_basement_area;
gen tot_area2 = tot_area^2;
gen tot_area3 = tot_area^3;

gen shape_ratio=shape_length/shape_area;

gen tot_bath = total_full_bath + .5*total_half_bath;
gen rooms = total_kitchens + total_dens + total_family + total_dining + total_living + total_other;
gen cars = stalls_garage_1+stalls_garage_2;
gen siding = 0 + 1*(siding_types_1_and_2==10) + 2*(siding_types_1_and_2==17)+3*(siding_types_1_and_2==20)+4*(siding_types_1_and_2==27)+5*(siding_types_1_and_2==50);

gen big_lot=lot_size*(lot_size>50000);
gen st_to_land=tot_area/lot_size; 
gen lot_size2=lot_size^2; 
gen lot_size3=lot_size^3; 

gen month = month(sale_date - 21916);
gen year = year(sale_date - 21916);

gen new=0;
replace new =1 if construction_yr==year | construction_yr==year-1;
gen age_home = year-construction_yr;
recode age_home min/5 = 1 6/10=2 11/25=3 26/50=4 51/100=5 100/max=6 ;

gen log_sp = ln(sale_price);


*determine exclusion for regressions ;

gen exclude = 0 ;
replace exclude = 1 if sale_price==. | sale_price==0;
replace exclude = 1 if construction_yr>year;
replace exclude = 1 if year-effective_yr<2; 
replace exclude = 1 if sale_date==.;
replace exclude = 1 if sale_price<50000;
replace exclude = 1 if sale_price>1000000;

* compute dummy variables;
xi i.age_home i.type_of_water_frontage i.cars i.tot_bath i.foundation i.windows i.story_height i.dwelling_units i.driveway_type i.fireplace_openings 
i.style i.roof i.quality_class i.inside_condition i.outside_condition i.siding_types_1_and_2 i.floor_types i.ceiling_types i.plumbing_class
i.airport_noise i.railroad_noise i.street_noise i.fuel_storage_proximity i.lot_type_1 i.lot_type_2 i.traffic i.water 
i.water i.sewer i.gas i.street i.alley i.curb_and_gutter i.sidewalk i.wooded i.landscaping i.topography_1 i.topography_2
i.external_influence i.parcel_view i.flood_plain i.deed_restrictions;

xi , prefix(_NE) i.assessment_area i.elementary_school i.middle_school i.high_school  i.national_historic_district 
i.urban_design_district;

xi , prefix(_T) i.year i.month ;

save data_for_AER, replace;
#delimit ;

reg log_sp st_to_land ground_floor_area t2nd_floor_area t3rd_floor_area finished_attic_area finished_basement_area 
lot_size lot_size2 lot_size3 tot_area tot_area2 tot_area3 big_lot shape_ratio shape_length central_air amp_rating
_Tyear* _Tmonth* sale_date _I* _NE*
d_SSB_nne d_SSB_sse d_SSB_nnw d_SSB_ssw d_SSB_nee d_SSB_see d_SSB_nww d_SSB_sww 
d_SSB_nne_2 d_SSB_sse_2 d_SSB_nnw_2 d_SSB_ssw_2 d_SSB_nee_2 d_SSB_see_2 d_SSB_nww_2 d_SSB_sww_2
d_SSB_nne_3 d_SSB_sse_3 d_SSB_nnw_3 d_SSB_ssw_3 d_SSB_nee_3 d_SSB_see_3 d_SSB_nww_3 d_SSB_sww_3
d_SSB_nne_4 d_SSB_sse_4 d_SSB_nnw_4 d_SSB_ssw_4 d_SSB_nee_4 d_SSB_see_4 d_SSB_nww_4 d_SSB_sww_4;

#delimit ;
reg log_sp st_to_land ground_floor_area t2nd_floor_area t3rd_floor_area finished_attic_area finished_basement_area 
lot_size lot_size2 lot_size3 tot_area tot_area2 tot_area3 big_lot shape_ratio shape_length central_air amp_rating
_Tyear* _Tmonth* sale_date _I* _NE*
d_SSB_nne d_SSB_sse d_SSB_nnw d_SSB_ssw d_SSB_nee d_SSB_see d_SSB_nww d_SSB_sww 
d_SSB_nne_2 d_SSB_sse_2 d_SSB_nnw_2 d_SSB_ssw_2 d_SSB_nee_2 d_SSB_see_2 d_SSB_nww_2 d_SSB_sww_2
d_SSB_nne_3 d_SSB_sse_3 d_SSB_nnw_3 d_SSB_ssw_3 d_SSB_nee_3 d_SSB_see_3 d_SSB_nww_3 d_SSB_sww_3
d_SSB_nne_4 d_SSB_sse_4 d_SSB_nnw_4 d_SSB_ssw_4 d_SSB_nee_4 d_SSB_see_4 d_SSB_nww_4 d_SSB_sww_4 if exclude==0;



